

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>Secure AP Command Interface &mdash; TISCI User Guide</title>
  

  
  
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
  

  

  
  
    

  

  
  
    <link rel="stylesheet" href="../../_static/css/theme.css" type="text/css" />
  

  
    <link rel="stylesheet" href="../../_static/theme_overrides.css" type="text/css" />
  

  
        <link rel="index" title="Index"
              href="../../genindex.html"/>
        <link rel="search" title="Search" href="../../search.html"/>
    <link rel="top" title="TISCI User Guide" href="../../index.html"/>
        <link rel="up" title="Chapter 2: TISCI Message Documentation" href="../index.html"/>
        <link rel="next" title="Runtime Debug TISCI Description" href="runtime_debug.html"/>
        <link rel="prev" title="Firewall TISCI Description" href="firewall_api.html"/> 

  
  <script src="../../_static/js/modernizr.min.js"></script>

</head>

<body class="wy-body-for-nav" role="document">
  <header id="tiHeader">
    <div class="top">
      <ul>
        <li id="top_logo">
          <a href="http://www.ti.com">
            <img src="../../_static/img/ti_logo.png"/>
          </a>
        </li>
      </ul>
    </div>
    <div class="nav"></div>
  </header>
  <div class="wy-grid-for-nav">

    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search">
          

          
            <a href="../../index.html" class="icon icon-home"> TISCI
          

          
          </a>

          
            
            
              <div class="version">
                11.00.04
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
                <ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../../1_intro/index.html">Chapter 1: Introduction</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="../index.html">Chapter 2: TISCI Message Documentation</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="../general/TISCI_header.html">Texas Instruments System Controller Interface (TISCI)</a></li>
<li class="toctree-l2"><a class="reference internal" href="../index.html#general">General</a></li>
<li class="toctree-l2"><a class="reference internal" href="../index.html#power-management-pm">Power Management (PM)</a></li>
<li class="toctree-l2"><a class="reference internal" href="../index.html#resource-management-rm">Resource Management (RM)</a></li>
<li class="toctree-l2 current"><a class="reference internal" href="../index.html#secure-management">Secure Management</a><ul class="current">
<li class="toctree-l3"><a class="reference internal" href="sec_cert_format.html">Security X509 Certificate Documentation</a></li>
<li class="toctree-l3"><a class="reference internal" href="PROC_BOOT.html">Processor Boot Management TISCI Description</a></li>
<li class="toctree-l3"><a class="reference internal" href="firewall_api.html">Firewall TISCI Description</a></li>
<li class="toctree-l3 current"><a class="current reference internal" href="#">Secure AP Command Interface</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#introduction">Introduction</a></li>
<li class="toctree-l4"><a class="reference internal" href="#data-transfer-protocol">Data transfer protocol</a></li>
<li class="toctree-l4"><a class="reference internal" href="#commands">Commands</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="runtime_debug.html">Runtime Debug TISCI Description</a></li>
<li class="toctree-l3"><a class="reference internal" href="extended_otp.html">Extended OTP TISCI Description</a></li>
<li class="toctree-l3"><a class="reference internal" href="dkek_management.html">Derived KEK TISCI Description</a></li>
<li class="toctree-l3"><a class="reference internal" href="dsmek_management.html">Derived SMEK TISCI Description</a></li>
<li class="toctree-l3"><a class="reference internal" href="security_handover.html">Security Handover Message Description</a></li>
<li class="toctree-l3"><a class="reference internal" href="keywriter.html">OTP Keywriter TISCI Description</a></li>
<li class="toctree-l3"><a class="reference internal" href="otp_revision.html">OTP Revision Read/Write Message Description</a></li>
<li class="toctree-l3"><a class="reference internal" href="keyring.html">KEYRING TISCI Description</a></li>
<li class="toctree-l3"><a class="reference internal" href="csp.html">Cryto Service TISCI Description</a></li>
<li class="toctree-l3"><a class="reference internal" href="fwl_safety_core.html">FIREWALL READ ACCESS SAFETY CORE TISCI Description</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../3_boardcfg/index.html">Chapter 3: Board Configuration</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../4_trace/index.html">Chapter 4: Interpreting Trace Data</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../5_soc_doc/index.html">Chapter 5: SoC Family Specific Documentation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../6_topic_user_guides/index.html">Chapter 6: Topic User Guides</a></li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
        <a href="../../index.html">TISCI</a>
      </nav>


      
      <div class="wy-nav-content">
        <div class="rst-content">
          

 



<div role="navigation" aria-label="breadcrumbs navigation">
  <ul class="wy-breadcrumbs">
    <li><a href="../../index.html">Docs</a> &raquo;</li>
      
          <li><a href="../index.html">Chapter 2: TISCI Message Documentation</a> &raquo;</li>
      
    <li>Secure AP Command Interface</li>
      <li class="wy-breadcrumbs-aside">
        
          
        
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <div class="section" id="secure-ap-command-interface">
<h1>Secure AP Command Interface<a class="headerlink" href="#secure-ap-command-interface" title="Permalink to this headline">¶</a></h1>
<div class="section" id="introduction">
<span id="sec-ap-cmd-if-intro"></span><h2>Introduction<a class="headerlink" href="#introduction" title="Permalink to this headline">¶</a></h2>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">This document is applicable to HS devices only.</p>
</div>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">Opening the JTAG port through the Secure AP command interface is the primary
method of unlocking JTAG on K3 devices. For debug flexbility, System Firmware also
supports unlocking JTAG on target via a TISCI command. This is documented in
<a class="reference internal" href="runtime_debug.html"><span class="doc">Runtime Debug TISCI Description</span></a>.</p>
</div>
<p>On K3 HS devices, the JTAG port is closed by default. At device run-time, access
to JTAG port is controlled by System Firmware using knobs provided by the
hardware. An external debugger should communicate with System Firmware running
via Secure Access Point (Sec AP) in the DebugSS and unlock the required debug
functionality.</p>
<p>This document lists</p>
<ol class="arabic simple">
<li>the commands that can be used by the external debugger,</li>
<li>the response to the commands from software running on DMSC</li>
<li>the format of the payload for the commands and responses</li>
<li>the communication protocol to be used for command and data transfer.</li>
</ol>
</div>
<div class="section" id="data-transfer-protocol">
<span id="sec-ap-cmd-if-data-rxtx-proto"></span><h2>Data transfer protocol<a class="headerlink" href="#data-transfer-protocol" title="Permalink to this headline">¶</a></h2>
<ol class="arabic simple">
<li>All data is transferred one word at a time. Each word is 32 bits in
length.</li>
</ol>
<div class="section" id="transmit-protocol">
<span id="sec-ap-cmd-if-data-tx-proto"></span><h3>Transmit protocol<a class="headerlink" href="#transmit-protocol" title="Permalink to this headline">¶</a></h3>
<ol class="arabic simple">
<li>Write the number of (remaining) words to be transmitted in the 16
msb’s of the TX control register. The 16 lsb’s are to be set as zero.</li>
<li>Write the word to be transmitted into the TX data register. The write
will automatically assert Bit 0 of the TX control register.</li>
<li>Wait for the target to read the data by polling until Bit 0 is
cleared.</li>
<li>Repeat steps (1), (2) and (3) until the complete data has been
transferred.</li>
</ol>
<p>Please note that one transmit transaction can contain theoritically
contain a maximum of 65535 words. This can be further limited based on
the command involved.</p>
</div>
<div class="section" id="receive-protocol">
<span id="sec-ap-cmd-if-data-rx-proto"></span><h3>Receive Protocol<a class="headerlink" href="#receive-protocol" title="Permalink to this headline">¶</a></h3>
<ol class="arabic simple">
<li>When waiting to receive data, poll the RX control register until Bit
0 is set to 1. This indicates that data is available in the RX data
register.</li>
<li>The 16 lsb’s of the RX Control register indicate the number of words
of the data that is yet to be read.</li>
<li>Read 1 word of data from RX data register. This automatically clears
Bit 0 of the RX control register.</li>
<li>Repeat steps (1), (2) and (3) until required data is read.</li>
</ol>
</div>
<div class="section" id="timeout-during-data-transfer">
<h3>Timeout during data transfer<a class="headerlink" href="#timeout-during-data-transfer" title="Permalink to this headline">¶</a></h3>
<p>System Firmware allows for a 360 ms delay between Words of a data transfer (read/write).
If a timeout occurs, System Firmware will discard the active SEC AP command.</p>
</div>
</div>
<div class="section" id="commands">
<span id="sec-ap-cmd-if-cmds"></span><h2>Commands<a class="headerlink" href="#commands" title="Permalink to this headline">¶</a></h2>
<p>Each command is a combination of</p>
<ol class="arabic simple">
<li>Command ID - 1 Word</li>
<li>Optional payload - N words where N depends on the command.</li>
</ol>
<div class="section" id="get-uid">
<span id="sec-ap-cmd-if-get-uid"></span><h3>Get UID<a class="headerlink" href="#get-uid" title="Permalink to this headline">¶</a></h3>
<p>This command is used to get the unique ID for the SOC to be used in the
debug certificate. See the below command.</p>
<p>The command ID is <code class="docutils literal"><span class="pre">0x80B5AE71</span></code>. There is no payload associated with
this command.</p>
<p>The response returns a 32 byte value i.e.&nbsp;8 Words. The MSB of Word[0]
contains the MSB of UID.</p>
<div class="highlight-cpp"><div class="highlight"><pre><span></span><span class="o">|</span><span class="w">      </span><span class="n">Word</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="w">        </span><span class="o">|</span><span class="w">   </span><span class="n">Word</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span><span class="w">    </span><span class="o">|</span><span class="w">     </span><span class="o">|</span><span class="w">  </span><span class="n">Word</span><span class="p">[</span><span class="mi">7</span><span class="p">]</span><span class="w"> </span><span class="o">|</span>
<span class="o">|</span><span class="w"> </span><span class="n">B</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="w"> </span><span class="n">B</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span><span class="w"> </span><span class="n">B</span><span class="p">[</span><span class="mi">2</span><span class="p">]</span><span class="w"> </span><span class="n">B</span><span class="p">[</span><span class="mi">3</span><span class="p">]</span><span class="w"> </span><span class="o">|</span><span class="w"> </span><span class="n">B</span><span class="p">[</span><span class="mi">4</span><span class="p">]</span><span class="w"> </span><span class="p">..</span><span class="w"> </span><span class="n">B</span><span class="p">[</span><span class="mi">7</span><span class="p">]</span><span class="w"> </span><span class="o">|</span><span class="w"> </span><span class="p">....</span><span class="o">|</span><span class="w">   </span><span class="n">B</span><span class="p">[</span><span class="mi">31</span><span class="p">]</span><span class="w">  </span><span class="o">|</span>
</pre></div>
</div>
</div>
<div class="section" id="open-jtag">
<span id="sec-ap-cmd-if-open-jtag"></span><h3>Open JTAG<a class="headerlink" href="#open-jtag" title="Permalink to this headline">¶</a></h3>
<p>This command is used to unlock the JTAG on a secure i.e.&nbsp;HS-SE device.
The command ID is <code class="docutils literal"><span class="pre">0x4968B2E9</span></code>. This payload for this command is a
X.509 certificate with the debug extension and signed by one of the keys
trusted in the customer board configuration.</p>
<p>The certificate can be a maximum of 4 KB in size.</p>
<p>The X509 certificate format is described in <a class="reference internal" href="sec_cert_format.html"><span class="doc">Security X509 Certificate Documentation</span></a>. The fields of
the certificate should be filled as specified in the
<a class="reference internal" href="sec_cert_format.html#sysfw-debug-ext"><span class="std std-ref">System Firmware Debug Extension</span></a>. The X509 debug extension is mandatory.
The other X509 extensions are not processed by System Firmware while performing JTAG
unlock.</p>
<p>This command has two responses.</p>
<ol class="arabic simple">
<li>If JTAG unlock is successful, it returns <code class="docutils literal"><span class="pre">0xDEAD3A17</span></code>.</li>
<li>If JTAG unlock is unsuccessful, it returns <code class="docutils literal"><span class="pre">0xDEADFA17</span></code>.</li>
</ol>
<p>If the command has failed, please review the settings in the certificate
before resending.</p>
<p>System Firmware will perform the following checks on the certificate
before attempting to apply the debug settings.</p>
<ol class="arabic simple">
<li>The signature on the certificate is verified with the public key in
the certificate.</li>
<li>The public key used to sign the certificate must be present in the
System Firmware Keystore.</li>
<li>Various parameters in the certificate are within the specified range.</li>
</ol>
<p>The command can be resent with a modified certificate if the JTAG unlock
command has failed. However once JTAG unlock is successful, the same
certificate needs to be used for subsequent unlock operations as well
until the device is reset. This is because most of the registers
controlling the debug operations can be written to only once after
device reset. With a different certificate, it is likely that one of the
debug registers need to be modified. The operation will fail as the
register cannot be modified.</p>
</div>
</div>
</div>


           </div>
          </div>
          <footer>
  
    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
      
        <a href="runtime_debug.html" class="btn btn-neutral float-right" title="Runtime Debug TISCI Description" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
      
      
        <a href="firewall_api.html" class="btn btn-neutral" title="Firewall TISCI Description" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
      
    </div>
  

  <hr/>

  <div role="contentinfo">
    <p>
      <a href="http://www.ti.com/corp/docs/legal/copyright.shtml">&copy; Copyright 2016-2025</a>, Texas Instruments Incorporated. All rights reserved. <br>
      <a href="http://www.ti.com/corp/docs/legal/trademark/trademrk.htm">Trademarks</a> | <a href="http://www.ti.com/corp/docs/legal/privacy.shtml">Privacy policy</a> | <a href="http://www.ti.com/corp/docs/legal/termsofuse.shtml">Terms of use</a> | <a href="http://www.ti.com/lsds/ti/legal/termsofsale.page">Terms of sale</a>

    </p>
  </div> 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  

    <script type="text/javascript">
        var DOCUMENTATION_OPTIONS = {
            URL_ROOT:'../../',
            VERSION:'11.00.04',
            COLLAPSE_INDEX:false,
            FILE_SUFFIX:'.html',
            HAS_SOURCE:  true
        };
    </script>
      <script type="text/javascript" src="../../_static/jquery.js"></script>
      <script type="text/javascript" src="../../_static/underscore.js"></script>
      <script type="text/javascript" src="../../_static/doctools.js"></script>
      <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.1/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>

    <script src="http://www.ti.com/assets/js/headerfooter/analytics.js" type="text/javascript" charset="utf-8"></script>

  

  
  
    <script type="text/javascript" src="../../_static/js/theme.js"></script>
  

  
  
  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.StickyNav.enable();
        });

      var menuHeight = window.innerHeight;

      var contentOffset = $(".wy-nav-content-wrap").offset();
      var contentHeight = $(".wy-nav-content-wrap").height();
      var contentBottom = contentOffset.top + contentHeight;

      function setNavbarTop() {
          var scrollTop = $(window).scrollTop();
          var maxTop = scrollTop + menuHeight;

          // If past the header
          if (scrollTop > contentOffset.top && maxTop < contentBottom) {
            stickyTop = scrollTop - contentOffset.top;
          } else if (maxTop > contentBottom) {
            stickyTop = scrollTop - contentOffset.top - (maxTop - contentBottom);
          } else {
            stickyTop = 0;
          }

          $(".wy-nav-side").css("top", stickyTop);
      }

      $(document).ready(function() {
        setNavbarTop();
        $(window).scroll(function () {
          setNavbarTop();
        });

        $('body').on("mousewheel", function () {
            // Remove default behavior
            event.preventDefault();
            // Scroll without smoothing
            var wheelDelta = event.wheelDelta;
            var currentScrollPosition = window.pageYOffset;
            window.scrollTo(0, currentScrollPosition - wheelDelta);
        });
      });
  </script>
   

</body>
</html>